/*************************** cvtsecs.c ***************************/

/******************************************************************************
 * Copyright (c) 1995,1996 Donated to the public domain                       *
 *                                                                            *
 * Original author and maintainer: Marc Chatel   (mchatel@dial.oleane.com)    *
 * Last known maintainer:          Marc Chatel   (mchatel@dial.oleane.com)    *
 *                                                                            *
 * This file was created as part of the S4 (Secure System Setup Script) kit.  *
 * Permission is granted to any person or entity to do any of the following:  *
 *       a) use this file alone or in some other software                     *
 *       b) modify this file or include parts of this file in other files     *
 *       c) re-distribute this file AS IS or modified, for non-commercial     *
 *          or commercial purposes, alone or as part of some software package *
 *                                                                            *
 * No warranties of any kind, express or implied, on the functionality and    *
 * safety of the contents of this file. Use at your own risk!                 *
 *                                                                            *
 * If you do useful changes to this file (bug fixes, portability fixes,       *
 * enhancements), you should TRY to contact the current maintainer, who may   *
 * be maintaining a "latest greatest" version of the file. You do not HAVE    *
 * TO, but you should TRY. Promote software reuse! It helps everybody,        *
 * including you!                                                             *
 ******************************************************************************/

#include <time.h>
#include <stdio.h>

/* This program expects one parameter, a date/time value expressed as a
   number of seconds since January 1st, 1970 in UTC time. It converts
   that to a local time and returns ASCII values for the year, month,
   day, hour, minute, and second */
   
int main( argc, argv )
int argc;
char **argv;
{
   time_t     supplied_time;
   struct tm  our_values, *tmp_ptr;

   if (argc !=2 ) return 1;
   supplied_time = atol( argv[1] );
   tmp_ptr = localtime( &supplied_time );
   our_values = *tmp_ptr;
   printf( "%4d %2d %2d %2d %2d %2d\n",
           our_values.tm_year + 1900,
           our_values.tm_mon + 1,
           our_values.tm_mday,
           our_values.tm_hour,
           our_values.tm_min,
           our_values.tm_sec );
   return 0;
}
