/******************** srchrepl.c *******************/

/******************************************************************************
 * Copyright (c) 1995,1996 Donated to the public domain                       *
 *                                                                            *
 * Original author and maintainer: Marc Chatel   (mchatel@dial.oleane.com)    *
 * Last known maintainer:          Marc Chatel   (mchatel@dial.oleane.com)    *
 *                                                                            *
 * This file was created as part of the S4 (Secure System Setup Script) kit.  *
 * Permission is granted to any person or entity to do any of the following:  *
 *       a) use this file alone or in some other software                     *
 *       b) modify this file or include parts of this file in other files     *
 *       c) re-distribute this file AS IS or modified, for non-commercial     *
 *          or commercial purposes, alone or as part of some software package *
 *                                                                            *
 * No warranties of any kind, express or implied, on the functionality and    *
 * safety of the contents of this file. Use at your own risk!                 *
 *                                                                            *
 * If you do useful changes to this file (bug fixes, portability fixes,       *
 * enhancements), you should TRY to contact the current maintainer, who may   *
 * be maintaining a "latest greatest" version of the file. You do not HAVE    *
 * TO, but you should TRY. Promote software reuse! It helps everybody,        *
 * including you!                                                             *
 ******************************************************************************/

/* Picked up from an old piece of code lying around that I wrote
   YEARS ago (and in a hurry back then). Search string criteria has been
   relaxed, but it is still lousy and inefficient code.

   This code is bad, but free. Anybody who wants it (I doubt it)
   can do whatever with it.

                                 Marc Chatel, January 1996. */

#include <stdio.h>
#include <string.h>
#include <malloc.h>

int main(argc,argv)
int   argc;
char *argv[];
{
   char           *srchstr;
   int             srchstr_len;
   char           *replstr;
   char           *inbuf;

   if (argc != 3)
   {
      fprintf(stderr,"%s: Must have exactly two arguments, the search string\n",
                     argv[0] );
      fprintf(stderr,
              "   and the replacement string. Use redirection symbols\n");
      fprintf(stderr,"   to select an input file and an output file.\n");
      return 1;
   }

   srchstr = argv[1];
   replstr = argv[2];

   srchstr_len = strlen( srchstr );

   inbuf = (char *) malloc( (size_t) (srchstr_len + 1) );

   if (inbuf == NULL)
   {
      fprintf( stderr, "%s: Cannot allocate buffer, exiting.\n", argv[0] );
      return 1;
   }


   while (1)
   {
      /* at the top of this loop, we have not found the first character
         of the search string yet, and the buffer is empty. */

      int ch;

      ch = getchar();
      if (ch == EOF) return 0;

      if ((ch & 255) != srchstr[0])   putchar(ch);
      else
      {
         int   done = 0;

         /* Try to load the same number of characters as the search string
            in the buffer. If we reach EOF before that, copy and finish */

         inbuf[0] = ch;

         {
            int i,j;

            for (i = 1; i < srchstr_len; i++)
            {
               ch = getchar();

               if (ch == EOF)
               {
                  for (j = 0; j < i; j++) putchar( inbuf[j] );
                  return 0;
               }

               inbuf[i] = ch;
            }
         }

         inbuf[srchstr_len] = '\0';

         /* inbuf is the same length as the search string.
            If the two are equal, we should substitute and go back to the
            main loop. */

         while (!done)
         {
            if (strcmp( inbuf, srchstr ) == 0)
            {
               printf( "%s", replstr );
               inbuf[0] = '\0'; done = 1;
            }
            else
            {
               /* the current inbuf is not an exact match. Calculate the
                  first character in inbuf which is a duplicate of inbuf[0].
                  If there is none, just output inbuf and go back to main
                  loop */

               int first_dupl = 0;
               int m;

               for (m = 1; m < srchstr_len; m++)
               {
                  if ((inbuf[0] == inbuf[m]) && (first_dupl == 0))
                     first_dupl = m;
               }
              
               if (first_dupl == 0)
               {
                  printf( "%s", inbuf ); inbuf[0] = '\0'; done = 1;
               }
               else
               {
                  int k;

                  /* copy all characters before the first duplicate */

                  for (k = 0; k < first_dupl; k++)
                  {
                     putchar(inbuf[k]);
                  }

                  /* move characters back to beginning of inbuf */

                  for (k = first_dupl; k < srchstr_len; k++)
                  {
                     inbuf[k - first_dupl] = inbuf[k];
                  }

                  /* try to read the number of characters necessary for
                     another test */

                  for (k = (srchstr_len - first_dupl); k < srchstr_len; k++)
                  {
                     int l;

                     ch = getchar();

                     if (ch == EOF)
                     {
                        for (l = 0; l < k; l++) putchar( inbuf[l] );
                        return 0;
                     }

                     inbuf[k] = ch;
                  }

                  /* if we make it here, we are ready to try one more time */
               }
            }
         } /* while (!done) */
      }
   } /* while (1) */
}
